// InsertDialog.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "PokePic.h"
#include "InsertDialog.h"
#include "gfxreader.h"


// CInsertDialog-Dialogfeld

IMPLEMENT_DYNAMIC(CInsertDialog, CDialog)
CInsertDialog::CInsertDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CInsertDialog::IDD, pParent)
	, OpenFile(_T(""))
	, offset(0)
	, Zoom(0)
	, m_iRows(0)
	, m_sSize(_T(""))
	, m_iSize(0)
{
}

CInsertDialog::~CInsertDialog()
{
}

void CInsertDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, offset);
	DDX_Text(pDX, IDC_ROWS, m_iRows);
	DDV_MinMaxInt(pDX, m_iRows, 1, 1000);
	DDX_Text(pDX, IDC_Size, m_sSize);
}


BEGIN_MESSAGE_MAP(CInsertDialog, CDialog)
	ON_BN_CLICKED(IDC_DUMP, OnBnClickedDump)
	ON_BN_CLICKED(IDC_INSERT, OnBnClickedInsert)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_SAVIMAGE, OnBnClickedSavimage)
	ON_BN_CLICKED(IDC_ZOOMIN, OnBnClickedZoomin)
	ON_BN_CLICKED(IDC_ZOOMOUT, OnBnClickedZoomout)
	ON_EN_CHANGE(IDC_ROWS, ReDraw)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
END_MESSAGE_MAP()


// CInsertDialog-Meldungshandler

void CInsertDialog::OnBnClickedDump()
{
	UpdateData(TRUE);
	CString Filename="mydmp.gba";
	static char BASED_CODE szFilter[] = "GBA Dumps (*.gba)|*.gba|Dump Files (*.dmp)|*.dmp||";
	CFileDialog dlg(FALSE, ".gba", Filename, 0,  szFilter);
	if(dlg.DoModal())
	{
        gfxreader dumper;
		dumper.dump((u32) offset, OpenFile ,dlg.GetPathName());

		ExportPng(&dumper.cFile[BUFFER/2], &m_bmpBitmap, 8, dumper.length);
		Invalidate();
		//
		//Rom.Read(dumper.cFile, BUFFER/2);
	//	dumper.UnCmpData(BUFFER/
		CString Message;

		
		m_iSize = dumper.source;
		m_sSize.Format("%X", m_iSize);
		UpdateData(FALSE);


		
	}

	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
}

void CInsertDialog::OnBnClickedInsert()
{
	UpdateData(TRUE);
	CString Filename="mydmp.gba";
	static char BASED_CODE szFilter[] = "GBA Dumps (*.gba)|*.gba|Dump Files (*.dmp)|*.dmp||";
	CFileDialog dlg(TRUE, ".gba", Filename, 0,  szFilter);
	if(dlg.DoModal())
	{
    
		u8 imagebuf[BUFFER/2];
		CFile gfx(dlg.GetPathName(), CFile::modeRead);

		gfx.Read(imagebuf, gfx.GetLength());
	    gfxreader ins;
		ins.BIOS_LZ77CompWram(imagebuf, gfx.GetLength(), 1);
		CString Message;
		Message.Format("Compressed size is: %X. Which is bigger than the space used to be. Really insert?", ins.filedatapos);
		gfx.Close();

if(m_iSize<ins.filedatapos)		
	if(MessageBox(Message, "Question", MB_OKCANCEL || MB_ICONQUESTION)==IDCANCEL)
		return;
		
		CFile Rom(OpenFile, CFile::modeWrite);
		Rom.Seek(offset, Rom.begin);
		Rom.Write(ins.filedata, ins.filedatapos);
		
	}

	
}

 int CInsertDialog::ExportPng(u8 *pUnCmpData, CImage *pImage, int rows, int size)
 {
	pImage->Destroy();
	int cols = size / (rows*64) * 2;
	pImage->Create(rows*8, cols*8, 8, 0);
	int x=0;
	int y=0;

	POINT point;
	point.x=x;
	point.y=y;

	u8 r[16];
	u8 g[16];
	u8 b[16];

	tagRGBQUAD colorref[16];

	for(int i=0; i<16; i++)
	{
		r[i] = i*16;
		g[i] = i*16;
		b[i] = i*16;

		colorref[i].rgbBlue=i*16;
		colorref[i].rgbGreen=i*16;
		colorref[i].rgbRed=i*16;
		colorref[i].rgbReserved=255;
	}

	pImage->SetColorTable(0, 16, colorref);
		


	for(int w=0; w<cols; w++)
	{

		for(int q=0; q<rows; q++)
		{

			for(int i=0; i<8; i++)
			{
		
				for(int j=0; j<4; j++)
				{
					unsigned char byte;
					unsigned char color1;
					unsigned char color2;
		
					byte = pUnCmpData[j+i*4+q*32+w*(32*rows)];
					color1 = (byte >> 4) & 0x0F;
					color2 = byte & 0x0F;
					pImage->SetPixel(point.x, point.y, RGB(r[color2], g[color2],b[color2]) );
					point.x++;
					pImage->SetPixel(point.x, point.y, RGB(r[color1], g[color1],b[color1])) ;
					point.x++;
				}
				point.y++;
				point.x-=8;
			}
			point.x+=8;
			point.y-=8;

		}
		point.x-=8*rows;
		point.y+=8;
	}
	return 0;
}

 void CInsertDialog::OnPaint()
 {
	 CPaintDC dc(this); // device context for painting
	 // TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein.
	 // CDialog::OnPaint() soll zum Zeichnen von Meldungen nicht aufgerufen werden.
	 if(!m_bmpBitmap.IsNull())
m_bmpBitmap.Draw(dc.m_hDC, 10, 100, (int) m_bmpBitmap.GetWidth()*Zoom, (int) m_bmpBitmap.GetHeight()*Zoom);
 }

 void CInsertDialog::OnBnClickedButton1()
 {
	 UpdateData(TRUE);
	 gfxreader dumper;
	dumper.dump(offset, OpenFile);

	row = (int) (sqrt(dumper.length*2) / 8);
	m_iRows = row;
	UpdateData(FALSE);

	ExportPng(&dumper.cFile[BUFFER/2], &m_bmpBitmap, row, dumper.length);
	Invalidate();

		m_iSize = dumper.source;
		m_sSize.Format("%X", m_iSize);
		UpdateData(FALSE);
	 
 }

 void CInsertDialog::OnBnClickedSavimage()
 {

	CString Filename="mypicture.png";
	static char BASED_CODE szFilter[] = "PNG Files (*.png)|*.png|Gif Files (*.gif)|*.gif||";
	CFileDialog dlg(FALSE, ".png", Filename, 0,  szFilter);
	if(dlg.DoModal())
	{
		UpdateData(TRUE);
		m_bmpBitmap.Save(dlg.GetPathName(), GUID_NULL);

	}
 }

 void CInsertDialog::OnBnClickedZoomin()
 {
	 // TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	 Zoom += 0.5;
	 Invalidate();
 }

 void CInsertDialog::OnBnClickedZoomout()
 {
	 // TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	 Zoom -= 0.5;
	 if(Zoom == 0)
		 Zoom=0.5;
	 Invalidate();
 }

 void CInsertDialog::ReDraw()
 {
	
	 UpdateData(TRUE);
	 gfxreader dumper;
	dumper.dump(offset, OpenFile);
	row = m_iRows;
	ExportPng(&dumper.cFile[BUFFER/2], &m_bmpBitmap, row, dumper.length);
	Invalidate();
 }



 void CInsertDialog::OnBnClickedButton2()
 {
	 // TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
CString m_strBitmap;
CString Message;
	 static char szFilter[] =
 "PNG Files (*.png)|*.png|GIF Files (*.gif)|*.gif|Bitmap Files (*.bmp)|*.bmp||";
 // Dialogfeld File Open erzeugen
 CFileDialog dlgFile(TRUE, ".png", "mybitmap.png",
 OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

 // Dialogfeld ffnen anzeigen und Ergebnis abfangen
 if (dlgFile.DoModal() == IDOK)
 {
 // Ausgewhlten Dateinamen ermitteln
 m_strBitmap = dlgFile.GetPathName();
 // Aktuelles Bild lschen
 m_bmpBitmap.Destroy();
 // Neues Bild laden
 m_bmpBitmap.Load(m_strBitmap);

UpdateData(TRUE);

	 gfxreader ins;
	 ins.CmpBmp(&m_bmpBitmap);

		Message.Format("Compressed size is: %X. Which is bigger than the space used to be. Really insert?", ins.filedatapos);

if(m_iSize<ins.filedatapos)		
	if(MessageBox(Message, "Question", MB_OKCANCEL || MB_ICONQUESTION)==IDCANCEL)
		return;
		
		CFile Rom(OpenFile, CFile::modeWrite);
		TRACE("HALLO! %d", ins.filedatapos);
//		MessageBox(OpenFile);
		Rom.Seek(offset, Rom.begin);
		Rom.Write(ins.filedata, ins.filedatapos);
		

 }
	 
 }
