#include "StdAfx.h"
#include "gfxreader.h"

gfxreader::gfxreader(void)
{
	// ofset table @ 001BCAF0
	// ofset pal @   001BED50
	// ofset backpic 001BDF90
	// ofset shiny   001BFB10
	Fronttable[0]=0x001E8354;
	Backtable[0]=0x001E97F4;
	Normalpal[0]=0x001EA5B4;
	Shinypal[0]=0x001EB374;
	Smallpic[0]=0x003BBD20;
	Smallpal[0]=0xE966D8;
	s_paltable[0]=0x3BC400;


//	Fronttable[1]=0x001C0CD8; // charatable
//	Fronttable[1]=0x001C1280; // ani-back-charatable
	Fronttable[1]=0x001E82E4; // real

	Backtable[1]=0x001E9784;
//	Normalpal[1]=0x001C0F70;  // charatable
	Normalpal[1]=0x001EA544;  // real
	Shinypal[1]=0x001EB304;
	Smallpic[1]=0x003BBD78;
	Smallpal[1]=0xE966D8;
	s_paltable[1]=0x3BC458;

}

gfxreader::~gfxreader(void)
{
}

gfxreader::ReadPic(int nr, CString Filename)
{
	// ofset table @ 001BCAF0
	// ofset pal @   001BED50
	// ofset backpic 001BDF90
	// ofset shiny   001BFB10

		CFile datei(Filename, CFile::modeRead);
		datei.Seek(Fronttable[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		datei.Close();
		long adr=CPUReadMemory(0);
		adr=adr & 0x00FFFFFF;
		Data(Filename, adr, FRONT);
		cmpsize[0] = source;
		cmpsize[0]=AddSize4(cmpsize[0]);
		

		datei.Open(Filename, CFile::modeRead);
		datei.Seek(Normalpal[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		datei.Close();
		adr=CPUReadMemory(0);
		adr=adr & 0x00FFFFFF;
		Pal(Filename, adr, NORMAL);
		cmpsize[1] = source;
		cmpsize[1]=AddSize4(cmpsize[1]);

		datei.Open(Filename, CFile::modeRead);
		datei.Seek(Backtable[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		datei.Close();
		adr=CPUReadMemory(0);
		adr=adr & 0x00FFFFFF;
		Data(Filename, adr, BACK);
		cmpsize[2] = source;
		cmpsize[2]=AddSize4(cmpsize[2]);

		datei.Open(Filename, CFile::modeRead);
		datei.Seek(Shinypal[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		datei.Close();
		adr=CPUReadMemory(0);
		adr=adr & 0x00FFFFFF; 
		Pal(Filename, adr, SHINY);	
		cmpsize[3] = source;
		cmpsize[3]=AddSize4(cmpsize[3]);

		datei.Open(Filename, CFile::modeRead);
		datei.Seek(Smallpic[Sapp]+(nr*4), datei.begin);
		datei.Read(cFile, 4);
		adr=CPUReadMemory(0);
		adr=adr & 0x00FFFFFF; 
		//adr=adr+0xFFFF;
		datei.Seek(adr, datei.begin);
		datei.Read(UnCmpData[2], 2048);

		datei.Seek(Smallpal[Sapp], datei.begin);
		datei.Read(UnCmpPal[2], 0x20);
		datei.Read(UnCmpPal[3], 0x20);
		datei.Read(UnCmpPal[4], 0x20);
        
		datei.Seek(s_paltable[Sapp]+nr, datei.begin);
		
		datei.Read(smallpal, 1);
		datei.Close();
	
	


	return 1;
}

int gfxreader::WritePic(int nr, CString Filename, u8 data[], int flag, int size)
{
	if(flag==0)
	{
		CFile datei(Filename, CFile::modeReadWrite);

        datei.Seek(Fronttable[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		long adr1=CPUReadMemory(0);
	/*	datei.Seek(Normalpal[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		long adr2=CPUReadMemory(0);
		int space=adr2-adr1;*/
		int space=cmpsize[0];
		if(space<size)
			return 12;

		adr1 = adr1 & 0x00FFFFFF;
		datei.Seek(adr1, datei.begin);
		datei.Write(data, space);
		
		datei.Close();
		return 1;
	}

	if(flag==1)
	{
		CFile datei(Filename, CFile::modeReadWrite);

        datei.Seek(Normalpal[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		long adr1=CPUReadMemory(0);
	/*	datei.Seek(Backtable[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		long adr2=CPUReadMemory(0);
		int space=adr2-adr1;*/
        int space=cmpsize[1];
		if(space<size)
			return 12;

		adr1 = adr1 & 0x00FFFFFF;
		datei.Seek(adr1, datei.begin);
		datei.Write(data, space);
		
		datei.Close();
		return 1;
	}
	if(flag==2)
	{
		CFile datei(Filename, CFile::modeReadWrite);

        datei.Seek(Backtable[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		long adr1=CPUReadMemory(0);
	/*	datei.Seek(Shinypal[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		long adr2=CPUReadMemory(0);
		int space=adr2-adr1;*/
		int space=cmpsize[2];
		if(space<size)
			return 12;

		adr1 = adr1 & 0x00FFFFFF;
		datei.Seek(adr1, datei.begin);
		datei.Write(data, space);
		
		datei.Close();
		return 2;
	}

	if(flag==3)
	{
		CFile datei(Filename, CFile::modeReadWrite);

        datei.Seek(Shinypal[Sapp]+(nr*8), datei.begin);
		datei.Read(cFile, 4);
		long adr1=CPUReadMemory(0);
	/*	datei.Seek(Smallpic[Sapp]+(nr*4), datei.begin);
		datei.Read(cFile, 4);
		long adr2=CPUReadMemory(0);
		int space=adr2-adr1;*/
		int space=cmpsize[3];
		if(space<size)
			return 12;

		/*datei.SeekToEnd();
		datei.GetPosition();*/

		adr1 = adr1 & 0x00FFFFFF;
		datei.Seek(adr1, datei.begin);
		datei.Write(data, space);
		
		datei.Close();
		return 2;
	}
		

	return 0;
}

u32 gfxreader::AddSize4(u32 var)
{
	while(var % 4 != 0)
		var++;
	return var;
}

int gfxreader::WritePicEnd(int nr, CString Filename, u8 data[], int flag, int size)
{
	if(flag==0)
	{
		CFile datei(Filename, CFile::modeReadWrite);
		datei.SeekToEnd();
		u32 adr = datei.GetPosition();
		datei.Write(data, size);
		adr = adr | 0x08000000;
		TRACE("adr=%X", adr);
		
		CPUWriteMemory(0, adr);
	//	TRACE("%X %X %X %X", cFile[0], cFile[1], cFile[2], cFile[3]);
		 datei.Seek(Fronttable[Sapp]+(nr*8), datei.begin);
		datei.Write(cFile, 4);
		
		datei.Close();
		return 1;
	}

	if(flag==1)
	{
		CFile datei(Filename, CFile::modeReadWrite);
		datei.SeekToEnd();
		u32 adr = datei.GetPosition();
		datei.Write(data, size);
		adr = adr | 0x08000000;
		TRACE("adr=%X", adr);
		
		CPUWriteMemory(0, adr);
		TRACE("%X%X%X%X", cFile[0], cFile[1], cFile[2], cFile[3]);
		datei.Seek(Normalpal[Sapp]+(nr*8), datei.begin);
		datei.Write(cFile, 4);

	
		
		datei.Close();
		return 1;

	}
	if(flag==2)
	{
	
		CFile datei(Filename, CFile::modeReadWrite);
		datei.SeekToEnd();
		u32 adr = datei.GetPosition();
		datei.Write(data, size);
		adr = adr | 0x08000000;
		
		CPUWriteMemory(0, adr);
		datei.Seek(Backtable[Sapp]+(nr*8), datei.begin);
		datei.Write(cFile, 4);
		
		datei.Close();
		return 1;
	}

	if(flag==3)
	{
		CFile datei(Filename, CFile::modeReadWrite);
		datei.SeekToEnd();
		u32 adr = datei.GetPosition();
		datei.Write(data, size);
		adr = adr | 0x08000000;
		
		CPUWriteMemory(0, adr);
		datei.Seek(Backtable[Sapp]+(nr*8), datei.begin);
		datei.Write(cFile, 4);
		
		datei.Close();
		return 1;
	}
		

	return 0;
}

int gfxreader::Bmp2Gba(CImage *Image, u8 *gbapic, u8 *gbapal)
 {
     int rows = Image->GetWidth()/8;
	 int cols = Image->GetHeight()/8;



tagRGBQUAD colorref[16];
Image->GetColorTable(0, 16, colorref);

 int gbacolor;


 		/*	r[i] = ((palbuf & 0x1F) <<3);
			g[i] = ((palbuf >> 5) & 0x1F) <<3;
			b[i] = (((palbuf >> 10) & 0x1f) <<3);*/ 

for(int i=0; i<16; i++)
{
gbacolor = ((colorref[i].rgbBlue>>3)<<10) | (colorref[i].rgbGreen>>3)<<5 | (colorref[i].rgbRed>>3);

gbapal[1+(i*2)]=(gbacolor >> 8);
gbapal[(i*2)]=(gbacolor & 0xFF);


}
COLORREF color;

		POINT point;
		point.x=0;
		point.y=0;


for(int w=0; w<cols; w++)
{

for(int q=0; q<rows; q++)
{

		for(int i=0; i<8; i++)
		{
		
		for(int j=0; j<4; j++)
		{
		unsigned char byte;
		unsigned char color1;
		unsigned char color2;
		

		color=Image->GetPixel(point.x, point.y);
		COLORREF palcol;
		color1=0;
		for( int t=0; t<16; t++) 
		{
		palcol= colorref[t].rgbRed | colorref[t].rgbGreen << 8 | colorref[t].rgbBlue<<16;
        if(palcol == color)
			color1=t;

		}

		point.x++;
		color=Image->GetPixel(point.x, point.y);
    
		color2=0;
		for( int t=0; t<16; t++) 
		{
		palcol= colorref[t].rgbRed | colorref[t].rgbGreen << 8 | colorref[t].rgbBlue<<16;
        if(palcol == color)
			color2=t;
		}
	//	dc->SetPixel(point, RGB(r[color1], g[color1],b[color1])) ;

		
		gbapic[j+i*4+q*32+w*(32*rows)]=color2<<4 | color1;



		point.x++;
		}
        point.y++;
		point.x-=8;
		}
 point.x+=8;
 point.y-=8;

}
 point.x-=8*rows;
 point.y+=8;
}

return (Image->GetWidth()*Image->GetHeight())/2;
 }

 void gfxreader::CmpBmp(CImage *Image)
 {
	u8 dummy[40];
	u8 imagebuf[BUFFER/2];

	u32 imgsize=Bmp2Gba(Image, &imagebuf[0], &dummy[0]);

	TRACE("Imagesize %d \r\n", imgsize);
	
	BIOS_LZ77CompWram(imagebuf, imgsize, 1);
	
 }