#include "StdAfx.h"
#include "lz77.h"

lz77::lz77(void)
{
}

lz77::~lz77(void)
{
}

		


u32 lz77::CPUReadMemory(int source)
{
	return cFile[source]+cFile[source+1]*256+cFile[source+2]*(256*256)+cFile[source+3]*(256*256*256);
//	return 0;
}

void lz77::CPUWriteMemory(int adress, u32 data)
{
	cFile[adress]=(data & 0x000000FF);
	cFile[adress+1]=(data & 0x0000FF00) >> 8;
	cFile[adress+2]=(data & 0x00FF0000) >> 16;
	cFile[adress+3]=(data & 0xFF000000) >> 24;


}

u8 lz77::CPUReadByte(int source)
{
	return cFile[source];
}


void lz77::CPUWriteByte(unsigned long a, unsigned char b)
{
	cFile[a]=b;

}



int lz77::Data(CString Filename, unsigned long adress, int type)
{
		for(int i=0; i<BUFFER; i++)
		cFile[i]=0;

	try {
		CFile datei(Filename, CFile::modeRead);
		datei.Seek(adress, datei.begin);
		datei.Read(cFile, BUFFER/2);
		datei.Close();
		source = 0;		
		BIOS_LZ77UnCompWram();
		for(int i=0; i<(2048*4); i++)
		{
			UnCmpData[type][i]= cFile[i+BUFFER/2];
		}
		return TRUE;
	}
	catch (CFileException *e){
	return FALSE;
	}
}

int lz77::Pal(CString Filename, unsigned long adress, int type)
{
		for(int i=0; i<BUFFER; i++)
		cFile[i]=0;

	try {
		CFile datei(Filename, CFile::modeRead);
		datei.Seek(adress, datei.begin);
		datei.Read(cFile, BUFFER/2);
		datei.Close();
		source = 0;		
		BIOS_LZ77UnCompWram();
		
	/*	for(int i=0; i<(32*4); i++)
		{
			UnCmpPal[type][i]= i;
		}*/

		for(int i=0; i<(32*4); i++)
		{
			UnCmpPal[type][i]= cFile[i+BUFFER/2];
		}
		return TRUE;
	}
	catch (CFileException *e){
	return FALSE;
	}
}





void lz77::BIOS_LZ77UnCompWram()
{


  source=0;
  
  u32 dest = BUFFER/2;

  u32 header = CPUReadMemory(source);
  source += 4;

  // this is just to check if everything is alright 
 /* if(((source & 0xe000000) == 0) ||
     ((source + ((header >> 8) & 0x1fffff)) & 0xe000000) == 0)
    return;  */
  
  int len = header >> 8;
	length = len;

	TRACE("\r\n leng: %d \r\n", len);

if(length>BUFFER/2)
	return;

  while(len > 0) {
    u8 d = CPUReadByte(source++);

    if(d) {
      for(int i = 0; i < 8; i++) {
        if(d & 0x80) {
			// note this is different in the vba source but it did not work for me before
       		u16 data = (CPUReadByte(source)<<8);
			source++;
			data = data | CPUReadByte(source++);

		
          int length = (data >> 12) + 3;
          int offset = (data & 0x0FFF);
          u32 windowOffset = dest - offset - 1;
          for(int i = 0; i < length; i++) {
            CPUWriteByte(dest++, CPUReadByte(windowOffset++));
            len--;
            if(len == 0)
              return;
          }
        } else {
          CPUWriteByte(dest++, CPUReadByte(source++));
          len--;
          if(len == 0)
            return;
        }
        d <<= 1;
      }
    } else {
      for(int i = 0; i < 8; i++) {
        CPUWriteByte(dest++, CPUReadByte(source++));
        len--;
        if(len == 0)
          return;
      }
    }
  }
}

void lz77::BIOS_LZ77CompWram(u8 data[], int size, int compression)
{


/*	CFile file("0x36f250.gba", CFile::modeRead);
	file.Read(data, 8192);
	file.Close();
	size = 8192;*/
	
  // : array [0..10000] of byte;

	for(int i=0; i<10000; i++)
		filedata[i]=0;

  int l, z; //byte
  //data : array [1..17000] of byte;
  u32 cmpdata[16]; // : array [2..18] of word;
  for(int i=0; i<16; i++)
	cmpdata[i]=0;


  int slidingwindowsize; //: integer; //word
 // size : integer; //word
  int position;// : integer; //word
  int buffersize;// : integer; //byte
  int testpos;// : integer; //word
  int testmatch;// : integer; //byte
  int count;// : integer; //byte
  int match;// : integer; //byte
  int slidingwindowmov;// : integer; //word
  int data1; // : integer; //word
  int data2; // : integer; //word
  int tmpcmpbyte; // : integer; //byte
 // int filedatapos; // : integer; //word
  CString destname; // : string;
  int fin; // : integer; //byte
//  int delta, starttime;// : integer;
  int flagbyte;// : integer; //byte

  fin = 0;

  position = 0;
  testpos = 1;
  filedatapos = 0;
  tmpcmpbyte = -1;
  flagbyte = 0;

   // write header
   filedata [0] = 0x10;
   filedata [1] = (size & 0xff);
   filedata [2] = ((size & 0xff00) >> 8);
   filedata [3] = ((size & 0xff0000) >> 16);
   filedatapos = 4;

   //TRACE("OKAY IT HAS STARTED");

   for(int i=0; i<=compression; i++)
   {
	tmpcmpbyte++;
	cmpdata[2*tmpcmpbyte] = data[i];
	position++;
   }

	slidingwindowsize = position-1;
	slidingwindowmov = compression;

	while (position < size) 
	{
	//	position++;
		
		count = 0;
		if (size-position>18) 
			buffersize = 18;
		else
			buffersize = size-position;

		testmatch = 2;

		do 
		{
			match = 0;
			l=0;

			while(data[position-slidingwindowmov-1] != data[position] )
			{
				slidingwindowmov++;
				if (slidingwindowmov>slidingwindowsize-1)
					break;			
			}

			for(int j = 1; j<=buffersize; j++)
			{
				//TRACE("FOR HAS STARTED \r\n");
				if(data[position+l-slidingwindowmov-1] == data[position+j-1] )
				{
					match++;

				}
				else
				{
				//	match--;
					break;

				}
				l++;
				if(l-slidingwindowmov == 1)
					l = 0;


			}


			
//TRACE("FOR HAS ENDED \r\n");
			if (match > testmatch)
			{
				testmatch = match;
				testpos = slidingwindowmov;
				// If it is the very last data to compress, set a flag to end the compression

			if (testmatch+position+1 > size) 
				fin = tmpcmpbyte+2;

//
			}
			if (position+2 > size) 
				fin = tmpcmpbyte+2;

			slidingwindowmov++;
//TRACE("slidingwindowmov %d, slidingwindowsize %d  \r\n", slidingwindowmov, slidingwindowsize);
		}
		while(!((slidingwindowmov>slidingwindowsize-1) || (testmatch == buffersize))); 
//TRACE("Do WHILE HAS ENDED \r\n");
		tmpcmpbyte++;

		if (testmatch <3)
		{
			flagbyte = (flagbyte << 1);
			cmpdata[2*tmpcmpbyte] = data[position]; // copy a raw byte
	//		TRACE("WROTE to cmpdata %d \r\n", 2*tmpcmpbyte);
			position++;
			slidingwindowsize++;
		}
		else // data can be compressed
		{
			flagbyte = (flagbyte << 1)+1;
			cmpdata[2*tmpcmpbyte] = testmatch-3; //number of byte to copy -3
			cmpdata[2*tmpcmpbyte+1] = testpos;
			position+=testmatch;
			slidingwindowsize+=testmatch;
		}

		if (slidingwindowsize > 0xfff)
			 slidingwindowsize = 0xfff;

		slidingwindowmov = compression;


		if ((tmpcmpbyte == 7) || (fin > 0))
		{
			if (fin <= 0) 
				count=7;
			else
				count=fin-1;

			filedata[filedatapos] = flagbyte;

			

			if (fin >0)
				filedata[filedatapos] = filedata[filedatapos] << (8-fin);
            filedatapos++;


			for (int i = 0; i<=count; i++)
			{

				if ((flagbyte & (1 << (count-i))) !=0)
				{
             //   if (cmpdata[2*i+1] > $fff) then showmessage ('error! '+inttohex(filedatapos,8));
                data1 = (cmpdata[2*i+1] & 0xff);
                data1 = data1 << 4;
                data1 =  data1 + cmpdata[2*i];
                data1 = data1 << 4;
                data2 = (cmpdata[2*i+1] & 0xf00);
                data2 = data2 >> 8;
                data1 = data1+data2;
                filedata[filedatapos+1] = (data1 & 0xff00) >> 8;
                filedata[filedatapos] = (data1 & 0xff);
				
                filedatapos+=2;


			/*	data2 = data2 >> 8;
                data1 = data1+data2;
                data1 = 0;
                filedata[filedatapos+1] = (data1 & 0xff00) >> 8;
                filedata[filedatapos] = (data1 & 0xff);
                filedatapos = filedatapos+2;*/
				}
				else
				{
					filedata[filedatapos] = cmpdata[2*i];
                    filedatapos++;


				}

			}
			tmpcmpbyte = -1;


		}
	
		
	}
	filedata[filedatapos] = 0;


	if (((filedatapos) & 3) !=0)
	{
		for (int i = 1; i<=(4-(filedatapos & 3)); i++)
			filedata[filedatapos+i] = 0;
		filedatapos = filedatapos + (4-(filedatapos & 3));

    }

	/*CFile datei("cmpdmp.hex", CFile::modeWrite);
	datei.Write(filedata, filedatapos);*/

}
int lz77::dump(u32 offset, CString Filename, CString Dumpname)
{
	CFile datei(Filename, CFile::modeRead);
	datei.Seek(offset, datei.begin);
	datei.Read(cFile, BUFFER/2);
	datei.Close();

	BIOS_LZ77UnCompWram();
	u8 *pBuffer = &cFile[BUFFER/2];
	CFile datafile(Dumpname, CFile::modeCreate | CFile::modeWrite);
	TRACE("length: %d \r\n", length);
    datafile.Write(pBuffer, length);
	//delete pBuffer;

	return 0;
}
int lz77::dump(u32 offset, CString Filename)
{
	CFile datei(Filename, CFile::modeRead);
	datei.Seek(offset, datei.begin);
	datei.Read(cFile, BUFFER/2);
	datei.Close();

	BIOS_LZ77UnCompWram();
	//delete pBuffer;

	return 0;
}

